package sun.security.provider;

import java.security.Provider;
import java.util.Hashtable;

public final class Sun extends Provider {
   private static String info = "SUN Security Provider v1.0, DSA signing and key generation, SHA-1 and MD5 message digests.";

   public Sun() {
      super("SUN", (double)1.0F, info);
      ((Hashtable)this).put("Signature.DSA", "sun.security.provider.DSA");
      ((Hashtable)this).put("Alg.Alias.Signature.SHA/DSA", "DSA");
      ((Hashtable)this).put("Alg.Alias.Signature.SHA-1/DSA", "DSA");
      ((Hashtable)this).put("Alg.Alias.Signature.DSS", "DSA");
      ((Hashtable)this).put("Alg.Alias.Signature.OID:1.3.14.3.2.13", "DSA");
      ((Hashtable)this).put("KeyPairGenerator.DSA", "sun.security.provider.DSAKeyPairGenerator");
      ((Hashtable)this).put("Alg.Alias.KeyPairGenerator.OID:1.3.14.3.2.12", "DSA");
      ((Hashtable)this).put("MessageDigest.MD5", "sun.security.provider.MD5");
      ((Hashtable)this).put("MessageDigest.SHA-1", "sun.security.provider.SHA");
      ((Hashtable)this).put("Alg.Alias.MessageDigest.SHA", "SHA-1");
      ((Hashtable)this).put("Alg.Class.DSA", "sun.security.x509.AlgIdDSA");
      ((Hashtable)this).put("Alg.Class.1.3.14.3.2.12", "sun.security.x509.AlgIdDSA");
      ((Hashtable)this).put("Alg.Alias.Signature.1.3.14.3.2.13", "DSA");
      ((Hashtable)this).put("Alg.Alias.Signature.SHAwithDSA", "DSA");
      ((Hashtable)this).put("Alg.Alias.Signature.SHA1withDSA", "DSA");
      ((Hashtable)this).put("Alg.Alias.KeyPairGenerator.1.3.14.3.2.12", "DSA");
      ((Hashtable)this).put("PublicKey.X.509.DSA", "sun.security.provider.DSAPublicKey");
      ((Hashtable)this).put("PrivateKey.PKCS#8.DSA", "sun.security.provider.DSAPrivateKey");
   }
}
