package sun.security.provider;

import java.io.Serializable;
import java.security.Certificate;
import java.security.Identity;
import java.security.IdentityScope;
import java.security.InvalidParameterException;
import java.security.KeyManagementException;
import java.security.PublicKey;

public class SystemIdentity extends Identity implements Serializable {
   boolean trusted = false;
   private String info;

   public SystemIdentity(String var1, IdentityScope var2) throws InvalidParameterException, KeyManagementException {
      super(var1, var2);
      if (var2 == null) {
         throw new InvalidParameterException("scope cannot be null");
      }
   }

   public boolean isTrusted() {
      return this.trusted;
   }

   protected void setTrusted(boolean var1) {
      this.trusted = var1;
   }

   void setIdentityInfo(String var1) {
      super.setInfo(var1);
   }

   String getIndentityInfo() {
      return super.getInfo();
   }

   void setIdentityPublicKey(PublicKey var1) throws KeyManagementException {
      ((Identity)this).setPublicKey(var1);
   }

   void addIdentityCertificate(Certificate var1) throws KeyManagementException {
      ((Identity)this).addCertificate(var1);
   }

   void clearCertificates() throws KeyManagementException {
      Certificate[] var1 = ((Identity)this).certificates();

      for(int var2 = 0; var2 < var1.length; ++var2) {
         ((Identity)this).removeCertificate(var1[var2]);
      }

   }

   public String toString() {
      String var1 = "not trusted";
      if (this.trusted) {
         var1 = "trusted";
      }

      return super.toString() + "[" + var1 + "]";
   }
}
