package sun.security.provider;

import java.security.Certificate;
import java.security.Identity;
import java.security.IdentityScope;
import java.security.InvalidParameterException;
import java.security.KeyException;
import java.security.KeyManagementException;
import java.security.KeyPair;
import java.security.PrivateKey;
import java.security.Signer;

public class SystemSigner extends Signer {
   private boolean trusted = false;

   public SystemSigner(String var1) {
      super(var1);
   }

   public SystemSigner(String var1, IdentityScope var2) throws KeyManagementException {
      super(var1, var2);
   }

   void setTrusted(boolean var1) {
      this.trusted = var1;
   }

   public boolean isTrusted() {
      return this.trusted;
   }

   void setSignerKeyPair(KeyPair var1) throws InvalidParameterException, KeyException {
      ((Signer)this).setKeyPair(var1);
   }

   PrivateKey getSignerPrivateKey() {
      return ((Signer)this).getPrivateKey();
   }

   void setSignerInfo(String var1) {
      ((Identity)this).setInfo(var1);
   }

   void addSignerCertificate(Certificate var1) throws KeyManagementException {
      ((Identity)this).addCertificate(var1);
   }

   void clearCertificates() throws KeyManagementException {
      Certificate[] var1 = ((Identity)this).certificates();

      for(int var2 = 0; var2 < var1.length; ++var2) {
         ((Identity)this).removeCertificate(var1[var2]);
      }

   }

   public String toString() {
      String var1 = "not trusted";
      if (this.trusted) {
         var1 = "trusted";
      }

      return super.toString() + "[" + var1 + "]";
   }
}
